#ifndef __log_h
#define __log_h

/* types */
#define LOG_COMMON 1
#define LOG_COMBINED 2
#define LOG_ATOP 3

/* parse*() fills in this struct */
struct logbits {
	char *url;                /* pointer to URL string */
	int url_pos;              /* location of url in urlmap */

	char *ip;                 /* pointer to IP/host string */
	unsigned int ipl;         /* numerical representation of IP */
	int ip_pos;               /* location of ip in ipmap */

	char *referrer;           /* pointer to referrer */
	int ref_pos;              /* location of referrer in map */

	unsigned short retcode;   /* return code */
	unsigned int bytes;       /* body of result page */
	time_t time;              /* time of request, unixtime */
};

class LogParser
{
	public:
	virtual int parse(char *logline, struct logbits *b) = 0;

	char *processURL(char **buf);
	int mungeURL(char **url, int *length);
};

class CommonLogParser : public LogParser
{
	int parse(char *logline, struct logbits *b);
};
class AtopLogParser : public LogParser
{
	int parse(char *logline, struct logbits *b);
};

#endif
